import http from "../http-common";
import store from "../store/index";

class DataService {
  fetchCitizenExistenceBasedOnSSN(citizenSSN : any): boolean {
    const citizenInformation = http.post('home/:ssn', {citizenSSN});
    if (citizenInformation) {
      this.setCitizenInformation(citizenInformation)
      return true;
    }
    else {
      return false;
    }
  }

  //All data has to be managed and stored from here (Exception Handling)
  setCitizenInformation(citizenInformation: any) {
    citizenInformation.then(
      (response: {
        data: {
          citizenInformation: {
            first_name: any; last_name: any; age: any; ssn: any; Training_Plans: any; Registered_Falls: any;
          };
        }
      }) => {
        store.dispatch("citizenProfile", [
          response.data.citizenInformation.first_name,
          response.data.citizenInformation.last_name, 
          response.data.citizenInformation.age, 
          response.data.citizenInformation.ssn
        ]);
        store.dispatch("trainingPlans", response.data.citizenInformation.Training_Plans);
        store.dispatch("registeredFalls", response.data.citizenInformation.Registered_Falls);
      }
    );
    citizenInformation.then(
      (response: {
        data: {
          predictionFromML: {
            CompleteProb: number; FallProb: number; ComplianceProb: number;
            CompleteShapValues: any; FallShapValues: any; Arguments: any;
          };
        }
      }) => {
        store.dispatch("probabilityComplete", response.data.predictionFromML.CompleteProb);
        store.dispatch("probabilityFall", response.data.predictionFromML.FallProb);
        store.dispatch("compliance", response.data.predictionFromML.ComplianceProb);
        store.dispatch("arguments", response.data.predictionFromML.Arguments);
        store.dispatch("shapComplete", response.data.predictionFromML.CompleteShapValues);
        store.dispatch("shapFall", response.data.predictionFromML.FallShapValues);
      }
    );
  }
}

export default new DataService();
